/*! Browser-Notebook - TERMS OF USE: GNU General Public License */
;
/*! pell_integration.js */
;"use strict";var EditorIntegration=(function(){var c;var e=function(){c=pell.init({element:document.getElementById("pell"),onChange:function j(){PageView.indicateUnsavedChanges(true)
},styleWithCSS:false,actions:["bold","italic","underline","strikethrough",{name:"red",icon:'<span style="background-color:red; font-size:16px">&nbsp;&nbsp;&nbsp;</span>',title:"Red Color",result:function i(){return pell.exec("foreColor","red")}},{name:"blue",icon:'<span style="background-color:blue; font-size:16px">&nbsp;&nbsp;&nbsp;</span>',title:"Blue Color",result:function i(){return pell.exec("foreColor","blue")
}},{name:"black",icon:'<span style="background-color:black; font-size:16px">&nbsp;&nbsp;&nbsp;</span>',title:"Black Color",result:function i(){return pell.exec("foreColor","black")}},{name:"green",icon:'<span style="background-color:green; font-size:16px">&nbsp;&nbsp;&nbsp;</span>',title:"Green Color",result:function i(){return pell.exec("foreColor","green")
}},{name:"gray",icon:'<span style="background-color:gray; font-size:16px">&nbsp;&nbsp;&nbsp;</span>',title:"Gray Color",result:function i(){return pell.exec("foreColor","gray")}},{name:"font size 2",icon:'<span style="font-size:9px">9</span>',title:"Font Size 2",result:function i(){return pell.exec("fontSize","2")
}},{name:"font size 3",icon:'<span style="font-size:12px">12</span>',title:"Font Size 3",result:function i(){return pell.exec("fontSize","3")}},{name:"font size 4",icon:'<span style="font-size:14px">14</span>',title:"Font Size 4",result:function i(){return pell.exec("fontSize","4")
}},{name:"font size 5",icon:'<span style="font-size:16px">16</span>',title:"Font Size 5",result:function i(){return pell.exec("fontSize","5")}},"line",{name:"link",result:function(){if(document.getElementById("passwordDiv").offsetParent!==null){alert(lang.first_enter_password);
return}const k=window.prompt("Enter the link (URL)");var l=/^(?:(?:https?|ftp):\/\/)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:\/\S*)?$/;
if(l.test(k)){window.pell.exec("insertHTML","<a href='"+k+"' title='"+k+"'>"+window.getSelection()+"</a>")}else{alert("Invalid Link...")}}},{name:"Image",icon:"<span>&#128507;</span>",title:"Image",result:function i(){if(document.getElementById("passwordDiv").offsetParent!==null){alert(lang.first_enter_password);
return}if(document.getElementById("importDiv")!==null){document.getElementById("importDiv").outerHTML=""}var n=document.createElement("div");n.setAttribute("id","importDiv");n.classList.add("shadowBorder");var m=document.createElement("input");m.setAttribute("id","inputFileImport");
m.setAttribute("type","file");m.setAttribute("title","browse file system");m.setAttribute("accept","image/*");m.addEventListener("change",function(q){var p=q.target.files[0];var o=new FileReader();o.readAsDataURL(p);o.onload=function(){pell.exec("insertHTML","<img src='"+o.result+"'>");
document.getElementById("importDiv").outerHTML=""};o.onerror=function(r){console.log("Error: ",r);alert("Could not load image")}});var k=document.createElement("label");k.setAttribute("for","inputFileImport");k.innerHTML=lang.select_image+":";n.appendChild(k);
n.appendChild(document.createElement("br"));n.appendChild(m);document.body.appendChild(n);document.getElementById("textDiv").parentNode.insertBefore(n,document.getElementById("textDiv"));var l=n.getBoundingClientRect();window.scrollTo(l.left,l.top);m.focus()
}},{name:"undo",icon:'<span style="font-size:18px">↶</span>',title:"Undo Action",result:function i(){return pell.exec("undo")}},{name:"redo",icon:'<span style="font-size:18px">↷</span>',title:"Redo Action",result:function i(){return pell.exec("redo")}}],classes:{actionbar:"pell-actionbar",button:"pell-button",content:"pell-content"}})
};var a=function(){};var b=function(){return c};var h=function(){var k=document.getElementsByClassName("pell-content");for(var j=0;j<k.length;j++){k[j].style.backgroundColor="lightgray";k[j].contentEditable="false"}};var g=function(){var k=document.getElementsByClassName("pell-content");
for(var j=0;j<k.length;j++){k[j].style.backgroundColor="#f2f2f2";k[j].contentEditable="true"}};var f=function(){return c.content.innerHTML};var d=function(i){c.content.innerHTML=i};return{setEditor:e,getEditor:b,disableEditor:h,enableEditor:g,getContent:f,setContent:d,doInitialSettings:a}
})();
/*! modified_convinience.js */
;"use strict";var BrowserNotebookSettings={storedKey:undefined,storedSalt:undefined,keyStored:false,pswChange:false,scryptIter:16384};sjcl.json={defaults:{v:1,iter:16384,ks:256,ts:128,mode:"ccm",adata:"",cipher:"aes"},_encryptWithScryptAndAES256:function(h,b,c,f){c=c||{};
f=f||{};var d=sjcl.json,a=d._add({iv:sjcl.random.randomWords(4,0)},d.defaults),e,g,i;if(f.adata){a.adata=f.adata;sjcl.json.defaults.adata=f.adata}if(f.iter){a.iter=f.iter;sjcl.json.defaults.iter=f.iter}d._add(a,c);i=a.adata;if(typeof a.salt==="string"){a.salt=sjcl.codec.base64.toBits(a.salt)
}if(typeof a.iv==="string"){a.iv=sjcl.codec.base64.toBits(a.iv)}if(!sjcl.mode[a.mode]||!sjcl.cipher[a.cipher]||(typeof h==="string"&&a.iter<=100)||(a.ts!==64&&a.ts!==96&&a.ts!==128)||(a.ks!==128&&a.ks!==192&&a.ks!==256)||(a.iv.length<2||a.iv.length>4)){throw new sjcl.exception.invalid("json encrypt: invalid parameters")
}if(h===null&&BrowserNotebookSettings.pswChange===false){h=BrowserNotebookSettings.storedKey;a.salt=BrowserNotebookSettings.storedSalt}else{if(typeof h==="string"){if(BrowserNotebookSettings.pswChange===false){console.log("_encrypt: Invalid parameter for pswChange: must be true");
return null}e=sjcl.misc.cachedScrypt(h,a);h=e.key.slice(0,a.ks/32);a.salt=e.salt;BrowserNotebookSettings.storedKey=h;BrowserNotebookSettings.storedSalt=e.salt;BrowserNotebookSettings.keyStored=true}else{if(sjcl.ecc&&h instanceof sjcl.ecc.elGamal.publicKey){e=h.kem();
a.kemtag=e.tag;h=e.key.slice(0,a.ks/32)}}}if(typeof b==="string"){b=sjcl.codec.utf8String.toBits(b)}if(typeof i==="string"){a.adata=i=sjcl.codec.utf8String.toBits(i)}g=new sjcl.cipher[a.cipher](h);d._add(f,a);f.key=h;if(a.mode==="ccm"&&sjcl.arrayBuffer&&sjcl.arrayBuffer.ccm&&b instanceof ArrayBuffer){a.ct=sjcl.arrayBuffer.ccm.encrypt(g,b,a.iv,i,a.ts)
}else{a.ct=sjcl.mode[a.mode].encrypt(g,b,a.iv,i,a.ts)}return a},encryptWithScryptAndAES256:function(c,e,b,g,d){BrowserNotebookSettings.pswChange=b;var a=sjcl.json,f=a._encryptWithScryptAndAES256.apply(a,arguments);return a.encode(f)},_decryptWithScryptAndAES256:function(i,b,c,f){c=c||{};
f=f||{};var d=sjcl.json,a=d._add(d._add(d._add({},d.defaults),b),c,true),g,e,h,k=a.adata;if(typeof a.salt==="string"){a.salt=sjcl.codec.base64.toBits(a.salt)}if(typeof a.iv==="string"){a.iv=sjcl.codec.base64.toBits(a.iv)}if(!sjcl.mode[a.mode]||!sjcl.cipher[a.cipher]||(typeof i==="string"&&a.iter<=100)||(a.ts!==64&&a.ts!==96&&a.ts!==128)||(a.ks!==128&&a.ks!==192&&a.ks!==256)||(!a.iv)||(a.iv.length<2||a.iv.length>4)){throw new sjcl.exception.invalid("json decrypt: invalid parameters")
}if(typeof i==="string"){BrowserNotebookSettings.scryptIter=a.iter;sjcl.json.defaults.iter=BrowserNotebookSettings.scryptIter;e=sjcl.misc.cachedScrypt(i,a);i=e.key.slice(0,a.ks/32);a.salt=e.salt;BrowserNotebookSettings.storedKey=i;BrowserNotebookSettings.storedSalt=e.salt;
BrowserNotebookSettings.keyStored=true}else{if(sjcl.ecc&&i instanceof sjcl.ecc.elGamal.secretKey){i=i.unkem(sjcl.codec.base64.toBits(a.kemtag)).slice(0,a.ks/32)}}if(typeof k==="string"){k=sjcl.codec.utf8String.toBits(k)}h=new sjcl.cipher[a.cipher](i);if(a.mode==="ccm"&&sjcl.arrayBuffer&&sjcl.arrayBuffer.ccm&&a.ct instanceof ArrayBuffer){g=sjcl.arrayBuffer.ccm.decrypt(h,a.ct,a.iv,a.tag,k,a.ts)
}else{g=sjcl.mode[a.mode].decrypt(h,a.ct,a.iv,k,a.ts)}d._add(f,a);f.key=i;if(c.raw===1){return g}else{return sjcl.codec.utf8String.fromBits(g)}},decryptWithScryptAndAES256:function(b,d,e,c){var a=sjcl.json;return a._decryptWithScryptAndAES256(b,a.decode(d),e,c)
},encode:function(d){var c,b="{",a="";for(c in d){if(d.hasOwnProperty(c)){if(!c.match(/^[a-z0-9]+$/i)){throw new sjcl.exception.invalid("json encode: invalid property name")}b+=a+'"'+c+'":';a=",";switch(typeof d[c]){case"number":case"boolean":b+=d[c];break;
case"string":b+='"'+escape(d[c])+'"';break;case"object":b+='"'+sjcl.codec.base64.fromBits(d[c],0)+'"';break;default:throw new sjcl.exception.bug("json encode: unsupported type")}}}return b+"}"},decode:function(f){f=f.replace(/\s/g,"");if(!f.match(/^\{.*\}$/)){throw new sjcl.exception.invalid("json decode: this isn't json!")
}var c=f.replace(/^\{|\}$/g,"").split(/,/),d={},e,b;for(e=0;e<c.length;e++){if(!(b=c[e].match(/^\s*(?:(["']?)([a-z][a-z0-9]*)\1)\s*:\s*(?:(-?\d+)|"([a-z0-9+\/%*_.@=\-]*)"|(true|false))$/i))){throw new sjcl.exception.invalid("json decode: this isn't json!")}if(b[3]!=null){d[b[2]]=parseInt(b[3],10)
}else{if(b[4]!=null){d[b[2]]=b[2].match(/^(ct|adata|salt|iv)$/)?sjcl.codec.base64.toBits(b[4]):unescape(b[4])}else{if(b[5]!=null){d[b[2]]=b[5]==="true"}}}}return d},_add:function(c,d,b){if(c===undefined){c={}}if(d===undefined){return c}var a;for(a in d){if(d.hasOwnProperty(a)){if(b&&c[a]!==undefined&&c[a]!==d[a]){throw new sjcl.exception.invalid("required parameter overridden")
}c[a]=d[a]}}return c},_subtract:function(d,c){var a={},b;for(b in d){if(d.hasOwnProperty(b)&&d[b]!==c[b]){a[b]=d[b]}}return a},_filter:function(d,c){var a={},b;for(b=0;b<c.length;b++){if(d[c[b]]!==undefined){a[c[b]]=d[c[b]]}}return a}};sjcl.encryptWithScryptAndAES256=sjcl.json.encryptWithScryptAndAES256;
sjcl.decryptWithScryptAndAES256=sjcl.json.decryptWithScryptAndAES256;sjcl.misc._scryptCache={};sjcl.misc.cachedScrypt=function(d,g){var b=sjcl.misc._scryptCache,i,f,h,e,a;g=g||{};a=g.iter||BrowserNotebookSettings.scryptIter;f=b[d]=b[d]||{};i=f[a]=f[a]||{firstSalt:(g.salt&&g.salt.length)?g.salt.slice(0):sjcl.random.randomWords(2,0)};
e=(g.salt===undefined)?i.firstSalt:g.salt;i[e]=i[e]||sjcl.misc.scrypt(d,e,a,8,1,256);return{key:i[e].slice(0),salt:e.slice(0)}};
/*! file_action.js: */
;"use strict";var FileAction=(function(){var c=function(g){window.localStorage.setItem(PswTitleAction.getTitle(),g);
var f=document.getElementById("importDiv");f.outerHTML="";PageView.showInputForm(false,true,false)};var a=function(f){if(f.hasOwnProperty("iv")&&f.hasOwnProperty("iter")&&f.hasOwnProperty("ks")&&f.hasOwnProperty("ts")&&f.hasOwnProperty("mode")&&f.hasOwnProperty("cipher")&&f.hasOwnProperty("salt")&&f.hasOwnProperty("ct")){return true
}else{alert(lang.missing_required_json_key);return false}};var b=function(j){var h=j.target.files[0];if(!h){return}var g=h.name.substring(0,h.name.lastIndexOf("."));if(BrowserNotebook.checkForExistingStorageKey(g)==true){var i=confirm(lang.existing_title+"\n"+g+"\n"+lang.import_overwrites);
if(i==false){console.log("break file import...");window.location.reload();return}}PswTitleAction.setTitle(g);var f=new FileReader();f.onload=function(l){var m=l.target.result;var k;try{k=JSON.parse(m)}catch(l){alert(lang.not_valid_json);return}if(a(k)===false){alert(lang.invalid_notebook_file+h.name);
return}PswTitleAction.setTitle(g);c(m)};f.readAsText(h)};var e=function(){if(document.getElementById("passwordDiv").offsetParent!==null){alert(lang.first_enter_password);return}PageView.closeExtraMenu();try{var j=BrowserNotebook.encryptAndSaveByStoredKey();
var h=new Blob([j],{type:"application/json"});if(window.navigator.msSaveOrOpenBlob){window.navigator.msSaveOrOpenBlob(h,PswTitleAction.getTitle()+".json")}else{var f=document.createElement("a");var g;if(window.URL&&window.URL.createObjectURL){var g=URL.createObjectURL(h)
}else{if(window.webkitURL){g=window.webkitURL.createObjectURL(h)}else{alert(lang.no_support_download);return}}f.href=g;f.download=PswTitleAction.getTitle()+".json";document.body.appendChild(f);f.click();setTimeout(function(){document.body.removeChild(f);window.URL.revokeObjectURL(g)
},0)}console.log("encrypted text exported in file "+PswTitleAction.getTitle()+".json")}catch(i){alert("Couldn't download the file "+PswTitleAction.getTitle()+":\n"+i)}};var d=function(){if(!(window.File&&window.FileReader)){alert(lang.no_support_upload);return
}PageView.closeExtraMenu();PageView.fileImportInput()};return{downloadFile:e,importFile:d,readSingleFile:b,validateNotebookJSON:a}})();
/*! page_view.js: */
;"use strict";var PageView=(function(){var b=false;var i=[];var k=function(){var n=localStorage.length;
if(n===0||n==null){return}for(var p=0;p<n;p++){try{var o=JSON.parse(localStorage.getItem(localStorage.key(p)))}catch(r){if(r instanceof SyntaxError){if(localStorage.key(p)==="lastTitle"){continue}else{console.log("Item of local storage is not a valid JSON object: "+localStorage.key(p));
console.log(localStorage.getItem(localStorage.key(p)));continue}}else{throw (r)}}if(FileAction.validateNotebookJSON(o)===true){var q=sjcl.codec.utf8String.fromBits(sjcl.codec.base64.toBits(o.adata));if(q.lastIndexOf(BrowserNotebook.programName,0)===0){if(!(q.indexOf(BrowserNotebook.version,q.length-BrowserNotebook.version.length)!==-1)){console.log("Wrong version of Browser Notebook: "+localStorage.key(p))
}i.push(localStorage.key(p))}else{if(localStorage.key(p)==="encryptedText"){console.log("Old version of Browser Notebook: "+localStorage.key(p));i.push(localStorage.key(p))}else{console.log("Not a Browser Notebook item: "+localStorage.key(p))}}}else{console.log("Missing required JSON key for cipher text: "+localStorage.key(p))
}}};var f=function(){return i.length};var g=function(){var r=document.getElementById("titleListDiv");var n=i.length;if(n===0||n==null){alert(lang.no_text_create);return}var p=localStorage.getItem("lastTitle");for(var o=0;o<n;o++){var t=i[o];var s=JSON.parse(localStorage.getItem(t));
var q='<div"><label style="border: 1px solid gray; padding:5px 10px 5px 5px"><input id="'+t+'" style="float: left" type="radio" name="titleSelection" onclick="PswTitleAction.setTitle(\''+t+"')\"";if(t==="encryptedText"){t="Old version text"}if(((p!=null)&&(p===t))||n===1){q+=' checked="checked"';
PswTitleAction.setTitle(t)}q+="/>"+t+"</label></div><br/><br/>";r.innerHTML+=q}if(r.childElementCount===0){alert("There is no valid encrypted text. \nCreate a new text: \n  File -> New...");r.style.display="none"}else{r.style.display="block"}};var j=function(s,z,v){var x=document.getElementById("formInputDiv");
if(s===false&&z===false&&v===false){x.style.display="none";return}else{if(x.style.display==="none"){x.style.display="block"}}var p=document.getElementById("titleDiv");var y=document.getElementById("titlePasswordSeparator");var r=document.getElementById("passwordDiv");
var q=document.getElementById("confirmDiv");var o=(p.offsetParent!==null);var w=(y.offsetParent!==null);var t=(r.offsetParent!==null);var n=(q.offsetParent!==null);if(s===true){document.getElementById("titleInput").value="";if(o===false){p.style.display="block";
if(z===true&&w===false){y.style.display="block"}}else{if(z===false&&w===true){y.style.display="none"}}}else{if(o===true){p.style.display="none";if(w===true){y.style.display="none"}}}if(z===true){if(t===false){r.style.display="block"}}else{if(t===true){r.style.display="none"
}}if(v===true){if(n===false){q.style.display="block"}}else{if(n===true){q.style.display="none"}}var u=x.getBoundingClientRect();window.scrollTo(u.left,u.top)};var m=function(n){if(n===true){if(b===false){document.getElementById("encryptButton").style.background="#b3ffb9"
}b=true}else{b=false;document.getElementById("encryptButton").style.background=""}};var e=function(){return b};var h=function(){j(false,false,false);document.getElementById("titleListDiv").style.display="none";document.getElementById("currentTitleDiv").innerHTML="";
if(document.getElementById("importDiv")!==null){document.getElementById("importDiv").outerHTML=""}var p=document.createElement("div");p.setAttribute("id","importDiv");p.classList.add("shadowBorder");var o=document.createElement("input");o.setAttribute("id","inputFileImport");
o.setAttribute("type","file");o.setAttribute("accept",".json, .JSON");o.addEventListener("change",FileAction.readSingleFile,false);p.appendChild(o);document.body.appendChild(p);document.getElementById("textDiv").parentNode.insertBefore(p,document.getElementById("textDiv"));
var n=p.getBoundingClientRect();window.scrollTo(n.left,n.top);o.focus()};var l=function(){try{a();var p=window.localStorage.getItem(PswTitleAction.getTitle());var n=document.getElementById("encryptedContent");n.innerHTML="<div id='encryptedTextDiv' style='word-wrap: break-word; height: "+(screen.height/3)+"px; overflow:auto'>"+PswTitleAction.getTitle()+".json:<br/>"+p+"</div><button  onclick='PageView.closeEncryptedText()' style='font-size:14px'>close</button>";
document.getElementById("encryptedTextModal").style.display="block"}catch(o){console.log(o);alert(window.localStorage.getItem(PswTitleAction.getTitle()))}};var c=function(){document.getElementById("encryptedTextModal").style.display="none"};var a=function(){var n=document.getElementById("extraMenuList").getElementsByTagName("*");
for(var o=0;o<n.length;o++){n[o].style.position="absolute"}};var d=function(){var n=document.getElementById("extraMenuList").getElementsByTagName("*");for(var o=0;o<n.length;o++){n[o].style.position="relative"}};return{loadTitles:k,getNumberOfTitles:f,showTitleList:g,showInputForm:j,indicateUnsavedChanges:m,isUnsavedChanges:e,fileImportInput:h,showEncryptedText:l,closeEncryptedText:c,closeExtraMenu:a,resetExtraMenu:d}
})();
/*! psw_title_action.js: */
;"use strict";var PswTitleAction=(function(){var a="";var m="";var f;var l=function(p){if(f==null){f=document.getElementById("hourglass")}try{f.style.visibility="visible"}catch(o){console.log(o)}try{document.styleSheets[0].insertRule("* {cursor: wait !important}",0)
}catch(o){if(o.name!=="SecurityError"){alert(lang.unexpected_error+"\n"+o.name+"\n"+o.message+"\n line: "+o.code)}}setTimeout(p,200)};var h=function(){try{f.style.visibility="hidden"}catch(o){console.log(o)}try{document.styleSheets[0].deleteRule(0)}catch(o){if(o.name!=="SecurityError"){throw o
}}};var b=function(o,q,t){try{var p=sjcl.decryptWithScryptAndAES256(o,q);if(document.getElementById("currentTitleDiv").offsetParent===null){BrowserNotebook.encryptAndSaveByStoredKey()}EditorIntegration.setContent(p);PageView.showInputForm(false,false,false);
PageView.indicateUnsavedChanges(false);EditorIntegration.enableEditor();if(document.getElementById("titleListDiv")!=null&&document.getElementById("titleListDiv").style.display==="block"){var s=document.getElementById("titleListDiv");while(s.firstChild!=null){s.removeChild(s.firstChild)
}}document.getElementById("currentTitleDiv").innerHTML='<span style="font-size:20px; font-weight: 900; border-style: solid;">'+PswTitleAction.getTitle()+"</span>"}catch(r){if(r.toString().match("tag doesn't match")){alert(lang.wrong_password);document.getElementById("passwordField").value="";
location.reload()}else{alert(lang.unexpected_error+"\n"+r.fileName+"\n"+r.lineNumber+"\n"+r.message);location.reload()}}finally{t()}};var n=function(p,q,u){if(p===null){alert(lang.first_enter_password);return}try{var o='{ "iter" : '+BrowserNotebook.getWorkFactor()+', "adata" : "'+BrowserNotebook.programName+BrowserNotebook.version+'" }';
var r=JSON.parse(o);var t=sjcl.encryptWithScryptAndAES256(p,q,true,r);window.localStorage.setItem(PswTitleAction.getTitle(),t);console.log("Encrypted text stored");PageView.showInputForm(false,false,false);PageView.indicateUnsavedChanges(false)}catch(s){if(s.toString().match("TypeError")&&s.toString().match("undefined")){alert(lang.first_enter_password);
console.log(s)}else{alert(lang.unexpected_error+" \n "+s)}}finally{u()}};var d=function(q,p){if(q.length!==p.length){return false}var o=0;for(var r=0;r<q.length;r++){o|=(q.charCodeAt(r)^p.charCodeAt(r))}if(o===0){return true}else{return false}};var g=function(o){o=o.replace('"',"_");
o=o.replace("'","_");o=o.replace("{","_");o=o.replace("}","_");o=o.replace("[","_");o=o.replace("]","_");o=o.replace(":","_");o=o.replace(",","_");o=o.replace(".","_");o=o.replace(";","_");o=o.replace("\\","_");return o};var i=function(){return a};var e=function(o){a=o
};var j=function(){if(document.getElementById("passwordDiv").offsetParent!==null){alert(lang.first_enter_password);return}m=a;PageView.showInputForm(true,false,false)};var c=function(){if(document.getElementById("passwordDiv").offsetParent!==null){alert(lang.first_enter_password);
return}PageView.closeExtraMenu();PageView.showInputForm(false,true,true)};var k=function(){if(document.getElementById("titleDiv").offsetParent!==null){var w=document.getElementById("titleInput").value;if(w==null||w===""){w="default"}w=g(w);if(BrowserNotebook.checkForExistingStorageKey(w)===true){var t=confirm(lang.existing_title+"\n"+w+"\n"+lang.import_overwrites);
if(t==false){console.log("break new text...");window.location.reload();return}}a=w}if(document.getElementById("confirmDiv").offsetParent!==null){var p=document.getElementById("passwordField").value;if(p===null||p===""){alert(lang.type_and_confirm);p="";return
}var v=document.getElementById("confirmPasswordField").value;if(v===null||v===""){alert(lang.confirm_password);return}if(d(p,v)===true){try{var q=EditorIntegration.getContent();l(function(){n(p,q,function(){h()})})}catch(s){console.log(s)}var o=false;document.getElementById("currentTitleDiv").innerHTML='<span style="font-size:20px; font-weight: 900; border-style: solid;">'+a+"</span>";
window.localStorage.setItem("lastTitle",a);EditorIntegration.enableEditor();if(q==null||q===""){}}else{alert(lang.password_confirm_not_equal);document.getElementById("confirmPasswordField").value="";return}}else{if(document.getElementById("passwordDiv").offsetParent===null){BrowserNotebook.encryptAndSaveByStoredKey();
document.getElementById("currentTitleDiv").innerHTML='<span style="font-size:20px; font-weight: 900; border-style: solid;">'+a+"</span>";window.localStorage.setItem("lastTitle",a);if(m!==""){localStorage.removeItem(m);m=""}else{console.log("Could not find old text title to remove...")
}}else{if(a==null||a===""){alert(lang.no_title_error);return}var p=document.getElementById("passwordField").value;if(p===null||p===""){alert(lang.first_enter_password);return}document.getElementById("passwordField").value="";var u=window.localStorage.getItem(a);
try{if(u){l(function(){b(p,u,function(){h()})});window.localStorage.setItem("lastTitle",a)}else{console.log("No stored text...")}}catch(s){console.log(s)}}}PageView.showInputForm(false,false,false);document.getElementById("titleListDiv").style.display="none"
};return{processInputForm:k,getTitle:i,setTitle:e,changePassword:c,changeTitle:j}})();
/*! browser-notebook.js: */
;"use strict";var BrowserNotebook=(function(){var d=false;var m=false;var b=false;var n=false;var f=16384;var j="0.4";var k="Browser Notebook ";
var q=function(r){if(r.target===document.getElementById("encryptedTextModal")){PageView.closeEncryptedText()}};var c=function(v,t){var r=[],s,u=255;if(t>0){r.push(v>>>24)}if(t>1){r.push((v>>>16)&u)}if(t>2){r.push((v>>>8)&u)}if(t>3){r.push(v&u)}return r};var p=function(r){if(typeof(Storage)==="undefined"){alert("Your browser does not support local storage.\n The reason is probably that your browser is outdated\n or local storage is disabled in your browser settings...");
var s=document.getElementById("passwordDiv");s.outerHTML="";s=document.getElementById("textDiv");s.outerHTML=""}else{console.log("local storage available");b=/MSIE 10/i.test(navigator.userAgent);n=window.navigator.userAgent.indexOf("Edge")>-1;d=("file:".match(window.location.protocol));
if((d)&&((b===true)||(n===true))){alert("Internet Explorer and Edge do not support local storage for non-server (offline) sites...")}}if((d===false)&&(location.protocol!="https:")){location.href="https:"+window.location.href.substring(window.location.protocol.length)
}if((d===false)&&(location.protocol!="https:")){alert("Warning: You are using HTTP protocol.\nYour communication is not protected...")}try{window.localStorage}catch(t){if(t instanceof DOMException){alert("To use this site in your current browser,\n you must enable third party cookies\n(although this site does not use them)\nor use Firefox to avoid the problem.");
console.log("Enable third party cookies in your browser")}}let touchEvent="ontouchstart" in window?"touchstart":"click";window.addEventListener(touchEvent,q);PageView.loadTitles();var u=PageView.getNumberOfTitles();if((window.localStorage.length===0)||(window.localStorage.length==null)||(u===0)){PageView.showInputForm(true,true,true);
document.getElementById("titleListDiv").style.display="none"}else{PageView.showInputForm(false,true,false)}EditorIntegration.setEditor();EditorIntegration.disableEditor();EditorIntegration.doInitialSettings();if(/android/i.test(window.navigator.userAgent)){m=true
}if(u>0){PageView.showTitleList()}};var l=function(t){var r=window.localStorage.length;for(var s=0;s<r;s++){if(t===localStorage.key(s)){return true}}return false};var h=function(){var s=EditorIntegration.getContent();var v;if(!s){alert(lang.no_text);return}else{try{var r='{ "adata" : "'+k+j+'" }';
var t=JSON.parse(r);var v=sjcl.encryptWithScryptAndAES256(null,s,false,t);window.localStorage.setItem(PswTitleAction.getTitle(),v);console.log("Encrypted text stored");PageView.indicateUnsavedChanges(false)}catch(u){alert(lang.unexpected_error)}}return v};var e=function(){if(PageView.isUnsavedChanges()===true){var t=confirm(lang.unsaved_changes);
if(t==true){try{h()}catch(s){console.log(s)}}}EditorIntegration.setContent("");window.location.reload()};var i=function(){if(document.getElementById("passwordDiv").offsetParent!==null){alert(lang.first_enter_password);return}var s=confirm(lang.text_lost);if(s==true){window.localStorage.setItem(PswTitleAction.getTitle(),"");
window.localStorage.removeItem(PswTitleAction.getTitle());EditorIntegration.setContent("");window.location.reload()}else{return}};var g=function(){EditorIntegration.setContent("");PageView.showInputForm(true,true,true)};var o=function(){return f};var a=function(u,t){f=t;
var s=u.target.parentElement.parentElement.getElementsByTagName("li");for(var r=0;r<s.length;r++){if(u.target.isEqualNode(s[r].firstChild)){s[r].firstChild.style.background="#00990d"}else{s[r].firstChild.style.background="#f8f8f8"}}document.getElementById("scryptSettings").style.display="inline";
if(document.getElementById("passwordDiv").offsetParent!==null){if(document.getElementById("titleDiv").offsetParent!==null){}else{alert(lang.apply_new_work_factor)}}else{EditorIntegration.disableEditor();PageView.showInputForm(false,true,true)}};return{programName:k,version:j,init:p,checkForExistingStorageKey:l,encryptAndSaveByStoredKey:h,quitProgram:e,clearStorage:i,newText:g,setWorkFactor:a,getWorkFactor:o}
})();window.onload=BrowserNotebook.init;